/*
 *  R : A Computer Langage for Statistical Data Analysis
 *  Copyright (C) 1995, 1996  Robert Gentleman and Ross Ihaka
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "Graphics.h"

void error(char*);
int ValidColor(int);

#define NA_REAL R_NaReal

extern double R_NaReal;

void GPolygon(int n, double *x, double *y, int col, int border, int usrcoords, int *work)
{
	int i, *ix, *iy;
	double xx, yy;
	ix = &work[0];
	iy = &work[n];

	for(i=0 ; i<n ; i++) {
		xx = x[i];
		yy = y[i];
		if(xx == NA_REAL || yy == NA_REAL)
			error("NA encountered in polygon\n");
		if(usrcoords) {
			xx = XMAP(xx);
			yy = YMAP(yy);
		}
		ix[i] = XFMAP(xx);
		iy[i] = YFMAP(yy);
	}

	/* If device can't clip we should use something */
	/* like Sutherland-Hodgman here */

	if(DP->canClip) GClip();

	if(col != NA_INTEGER) {
		GP->col = col;
		DevPolygon(n, ix, iy);
	}
	if(border != NA_INTEGER) {
		GP->col = border;
		GStartPath();
		xx = x[n-1];
		yy = y[n-1];
		if(usrcoords) {
			xx = XMAP(xx);
			yy = YMAP(yy);
		}
		GMoveTo(xx, yy);
		for(i=0 ; i<n ; i++) {
			xx = x[i];
			yy = y[i];
			if(usrcoords) {
				xx = XMAP(xx);
				yy = YMAP(yy);
			}
			GLineTo(xx, yy);
		}
		GEndPath();
	}
}
